open Value

let directory_contents directory =
  let d = Unix.opendir directory in
  let rec loop accu =
    match valuefy Unix.readdir d with
      | Value "." | Value ".." -> loop accu
      | Value v -> loop (v::accu)
      | Exn End_of_file -> List.rev accu
      | Exn e -> raise e
  in
  let v = valuefy loop [] in
    Unix.closedir d;
    devaluefy v
